from version import FIRMWARE_VERSION

import sys
sys.path.append("../../")
sys.path.append("../../webapp/")

from upload import upload, upgrade_firmware
from webapp import upload_folder_tree

import traceback
import sys

DEFAULT_IP="10.0.37.239"

if __name__ == '__main__':
    print(f"Ixys CS Switch updater {FIRMWARE_VERSION}")
    print("-------------------------------------")
    print(f"Make sure you're connected to the card's Ethernet interface.\n\nEnter the card's IP address, or press enter to use default [{DEFAULT_IP}].")
    ip = input() or DEFAULT_IP
    print("Trying to upload new web pages...")
    try:
        upload_folder_tree('html/', ip)

        upgrade_firmware("zephyr.signed.bin", ip)
    except Exception:
        print(traceback.format_exc())
        print("Something failed. See detailed error above, then press enter to close.")
        input()
        sys.exit(1)

    print("Upgrade succeded. Press enter to close, and wait for switch to reboot.")
    input()
    sys.exit(0)
