import argparse
import os
import requests
import time

from glob import glob
from string import Template

def upgrade_firmware(binary_file, ip):
    with open(binary_file, 'rb') as f:
        print("POSTing upgrade...")
        resp = requests.post(f"http://{ip}/upgrade/", f.read())
        print(resp, resp.text)


def erase_flash(ip):
    resp = requests.post(f"http://{ip}/command/eraseflash")
    print(resp, resp.text)


def upload(path, ip):
    for name in os.listdir(path):
        with open(os.path.join(path, name), 'rb') as f:
            data = f.read()
        r = requests.post(os.path.join(f"http://{ip}/html/", name), data)
        print(r, r.text)
        time.sleep(.5)


if __name__ == '__main__':
    from build_webfiles import build_webfiles

    a = argparse.ArgumentParser()
    a.add_argument("--folder", help="Pass this argument to upload full folder directly", default=None)
    #a.add_argument("html_files", help="Path to HTML files")
    #a.add_argument("res_files", help="Path to resource files (e.g. css, png, etc.)")
    #a.add_argument("out_files", help="Path to put processed files")
    a.add_argument("--ip", help="IP address of device", default="192.168.1.1")

    args = a.parse_args()

    if args.folder is not None:
        for f in glob(args.folder + "/**", recursive=True):
            if os.path.isfile(f):
                with open(os.path.join(args.folder, f), 'rb') as o:
                    data = o.read()
                f = f.replace("\\", "/")
                url = f"http://{args.ip}/html/{f}"
                print(f"Uploading to {url}...")
                r = requests.post(url, data)
                print(f, r, r.text)
                time.sleep(.5)
                #print(f)
                #upload(f, args.ip)
    else:
        build_webfiles(args.out_files, args.html_files, args.res_files)

        upload(args.out_files, args.ip)
